#include "./src/hypervisor/internal/elf.h"

#include <gint/display.h>
#include <gint/keyboard.h>


const struct dyngint gint_reloc[] = {
	/* display symbols */
	{.name = "_dclear",               .addr = (void*)&dclear},
	{.name = "_drect",                .addr = (void*)&drect},
	{.name = "_drect_border",         .addr = (void*)&drect_border},
	{.name = "_dpixel",               .addr = (void*)&dpixel},
	{.name = "_dline",                .addr = (void*)&dline},
	{.name = "_dhline",               .addr = (void*)&dhline},
	{.name = "_dvline",               .addr = (void*)&dvline},
	{.name = "_dfont",                .addr = (void*)&dfont},
	{.name = "_dsize",                .addr = (void*)&dsize},
	{.name = "_dtext_opt",            .addr = (void*)&dtext_opt},
	{.name = "_dtext",                .addr = (void*)&dtext},
	{.name = "_dprint_opt",           .addr = (void*)&dprint_opt},
	{.name = "_dprint",               .addr = (void*)&dprint},
	{.name = "_dimage",               .addr = (void*)&dimage},
	{.name = "_dsubimage",            .addr = (void*)&dsubimage},
	{.name = "_dupdate",              .addr = (void*)&dupdate},

	/* keyboard symbols */
	{.name = "_pollevent",           .addr = (void*)&pollevent},
	{.name = "_waitevent",           .addr = (void*)&waitevent},
	{.name = "_clearevants",         .addr = (void*)&clearevents},
	{.name = "_keydown",             .addr = (void*)&keydown},
	{.name = "_keydown_all",         .addr = (void*)&keydown_all},
	{.name = "_keydown_any",         .addr = (void*)&keydown_any},
	{.name = "_getkey",              .addr = (void*)&getkey},
	{.name = "_getkey_opt",          .addr = (void*)&getkey_opt},
	{.name = "_getkey_repeat",       .addr = (void*)&getkey_repeat},
	{.name = "_getkey_repeat_filter",.addr = (void*)&getkey_repeat_filter},
	{.name = "_keycode_function",    .addr = (void*)&keycode_function},
	{.name = "_keycode_digit",       .addr = (void*)&keycode_digit},

	/* end */
	{.name = NULL, .addr = (void*)NULL},
};
